SystemOrganization addCategory: #'GT-Inspector'!

!Dictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/24/2012 00:39'!
gtInspectorItemsIn: composite
	 (composite table)
		display: #associations;
		column: 'Key' evaluated:  [:each | 
			[ Text fromString: ((each key asString contractTo: 50) replaceAll: String cr with: String space) ] 
							on: Error 
							do: [ Text string: 'error printing' attribute: TextColor red ]];
		column: 'Value' evaluated: [:each | 
			[ Text fromString: ((each value asString contractTo: 50) replaceAll: String cr with: String space) ] 
							on: Error 
							do: [ Text string: 'error printing' attribute: TextColor red ]];
		beMultiple;
		title: [ :anObject | anObject size asString, ' items' ];
		searchOn: [:text :each | 
			Compiler evaluate: ' | entity each | each := self. entity := each.', text for: each logged: false];		
		send: [ :result | result size = 1 ifTrue: [result anyOne] ifFalse: [result]];
"		icon: [ :each |  
			| iconName |
			iconName := each class theNonMetaClass browserIcon ifNil: [#blank].
			OBMorphicIcons iconNamed: iconName ];"
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!Dictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:12'!
gtInspectorRetrieveVariableValuePairs  
	^ OrderedCollection new 
		add: ( 'self' -> self); 
		add: ( 'tally' -> self size );
		add: ( 'array' -> self array );
		yourself
! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:05'!
gtInspectorMethodsIn: composite
	<gtInspectorPresentationOrder: 50>
	composite custom: (GTSimpleMethodsBrowser new browser startOn: self) ! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:06'!
gtInspectorPresentationsIn: composite
	| pragmas |
	pragmas := Pragma 
				allNamed: #gtInspectorPresentationOrder: 
				from: self class 
				to: Object 
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas do: [ :eachPragma | 
		self perform: eachPragma selector with: composite ]
! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/28/2011 23:31'!
gtInspectorRetrieveVariableValuePairs
	"This is a helper method that returns a collection of variable names -> value for the current object.
	Subclasses can override it to specialize what appears in the variables presentation"
	| bindings |
	bindings := self class allInstVarNames 
					collect: [ :iv | iv -> (self instVarNamed: iv) ].
	^ OrderedCollection new
		add: '_self' -> self;
		addAll: bindings;
		yourself! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/27/2011 23:26'!
gtInspectorStateIn: composite
	<gtInspectorPresentationOrder: 10>
	composite custom: (GTObjectVariablesBrowser new browser startOn: self)! !

!ByteArray methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:52'!
gtInspectorItemsIn: composite! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/23/2011 07:30'!
gtInspectorBytecodeIn: composite
	<gtInspectorPresentationOrder: 40> 
	composite text 
		title: 'Bytecode';
		display: [:anObject | anObject symbolic ]! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:12'!
gtInspectorRetrieveVariableValuePairs
	| literalIndex |
	literalIndex := 0.
	^ OrderedCollection new 
		add: ( 'self' -> self); 
		add: ( 'header' -> self headerDescription );
		addAll: ( self literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ] );
		add: ( 'all bytecodes' -> self symbolic );
		yourself
! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/14/2012 22:39'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ :anObject | anObject methodClass ];
		display: [:anObject | anObject getSource ]! !

!Morph methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/25/2011 22:32'!
gtInspectorMorphIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:each | each imageForm asMorph ]! !

!Morph methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/2/2012 03:22'!
gtInspectorSubmorphsIn: composite
	<gtInspectorPresentationOrder: 80>  
	composite tree 
		title: 'Submorphs';
		rootsExpanded;
		display: [:each | {each} ];
		icon: [:each | | morphForm |
			morphForm := each imageForm.
			(morphForm extent x > 0 and: [morphForm extent y > 0 ])
				ifTrue: [(morphForm scaledToSize: 16@16) asMorph]
				ifFalse: [Form extent: 16@16] ];
		children: [:each | each submorphs];
		when: [:each | each submorphs notEmpty ]! !

!RBProgramNode methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/22/2012 20:38'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite custom: (GTSimpleParseTreeBrowser new browser startOn: self)! !

!String methodsFor: '*gt-inspector' stamp: 'TudorGirba 10/20/2011 15:44'!
gtInspectorITextIn: composite
	<gtInspectorPresentationOrder: 30>  
	 composite text
		title: 'String'! !

!String methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:19'!
gtInspectorItemsIn: composite
	"We do not offer the list of items for a String"! !

!Pragma class methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/23/2011 00:35'!
gtInspectorAnnotatedMethodsIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite list 
		title: 'All';
		showOnly: 50;
		withSmalltalkSearch;
		display: [:anObject | 
			| pragmas |
			pragmas := OrderedCollection new.
			Object withAllSubclassesDo: [:each |
				Pragma withPragmasIn: each do: [:p |
					pragmas add: p]].
			pragmas
		]! !

!Bitmap methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:49'!
gtInspectorItemsIn: composite
	"No items presentation for a Bitmap"! !

!Form methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:05'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:object | object asMorph]! !

!ContextPart methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/22/2012 20:38'!
gtInspectorRetrieveVariableValuePairs
	"We override the variables with context specific ones"
	| tempIndex |
	tempIndex := 0.
	^ super gtInspectorRetrieveVariableValuePairs
		addAll:
				(self tempNames
						collect: [ :tempName | 
							tempIndex := tempIndex + 1.
							('[' , tempName , ']') -> (self debuggerMap namedTempAt: tempIndex in: self) ]);
		yourself! !

!Collection methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/24/2012 00:40'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 30>  
	 (composite list)
		beMultiple;
		title: [ :anObject | anObject size asString, ' items' ];
		searchOn: [:text :each | 
			Compiler evaluate: ' | entity each | each := self. entity := each.', text for: each logged: false];		
		format: [ :each |
			[ Text fromString: ((each asString contractTo: 50) replaceAll: String cr with: String space) ] 
							on: Error 
							do: [ Text string: 'error printing' attribute: TextColor red ] ];
		send: [ :result | (result notNil and: [result size = 1]) ifTrue: [result anyOne] ifFalse: [result]];
"		icon: [ :each |  
			| iconName |
			iconName := each class theNonMetaClass browserIcon ifNil: [#blank].
			OBMorphicIcons iconNamed: iconName ];"
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

GLMBrowserTemplate subclass: #GTInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspector commentStamp: 'TudorGirba 8/21/2011 16:57' prior: 0!
This is meant to be used for inspecting objects. It offers multiple views and it uses a finder as a navigation. One particular feature is that you can use the evaluator tab to enter code, and evaluating it results in opening another pane to the right.

The object finder asks dynamically the object for the actual presentations that are displayed in each pane.

Example:
self openOn: Smalltalk.

Register it as a replacement for explorer:
self registerToolsOn: Smalltalk tools.!

!GTInspector classSide methodsFor: 'tools registry' stamp: 'TudorGirba 8/21/2011 16:57'!
registerToolsOn: registry
	"self registerToolsOn: Smalltalk tools " 
	registry register: self as: #objectExplorer
! !

!GTInspector methodsFor: 'building' stamp: 'TudorGirba 8/23/2011 22:57'!
buildBrowser
	browser := GLMFinder new.
	browser title: [:anObject | 'Inspector on ', (self printObjectAsAnItem: anObject)].
	browser act: [:b | b update] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Update'.
	browser show: [ :a | 
		a title: [ :anObject | self printObjectAsAnItem: anObject ].
		a 
			morphicAct: [:composite | composite entity browse]
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			entitled: 'Browse'.
		a dynamic 
			display: [:each | 
				| dynamic |
				dynamic := GLMCompositePresentation new.
				each gtInspectorPresentationsIn: dynamic.
				dynamic ] ].
	^ browser! !

!GTInspector methodsFor: 'opening' stamp: 'TudorGirba 8/21/2011 08:56'!
openExplorerFor: anObject
	"this method is needed for compatibility with ObjectExplorer"
	self openOn: anObject! !

!GTInspector methodsFor: 'private' stamp: 'TudorGirba 8/22/2011 11:05'!
printObjectAsAnItem: anObject 
	| title stream previewString |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	previewString := [ Text fromString: (anObject printString contractTo: 10) ]
						on: Error
						do: [ 'error printing' ].
	stream 
		nextPutAll: ' (';
		nextPutAll: previewString;
		nextPut: $).
	^ stream contents! !

GLMBrowserTemplate subclass: #GTObjectVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTObjectVariablesBrowser commentStamp: 'TudorGirba 8/22/2011 12:52' prior: 0!
This is a helper browser for the main view in the GTInspector.

Example:
self openOn: Smalltalk!

!GTObjectVariablesBrowser methodsFor: 'building' stamp: 'TudorGirba 8/22/2011 12:52'!
buildBrowser 
	browser := GLMTabulator new.
	browser title: 'State'.
	browser row: #variables; row: #evaluator.
	browser transmit to: #variables; andShow: [:a | 
		self variablesIn: a ].
	browser transmit to: #evaluator; andShow: [:a | 
		self evaluatorIn: a ].
	browser transmit from: #variables; toOutsidePort: #selection.
	browser transmit from: #evaluator; toOutsidePort: #selection.
	^ browser ! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 10/20/2011 15:31'!
evaluatorIn: composite
	(composite smalltalkCode)
		doItReceiver: #yourself;
		display: [ :entity | [entity printString asSmalltalkComment, String cr, 'self'] on: Error do: ['"Error printing. Try self printString to debug"'] ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :entity | Compiler evaluate: text selectedText for: entity logged: false ]! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 2/24/2012 00:41'!
variablesIn: composite
	composite table
		showOnly: 50;
		display: [ :anObject | anObject gtInspectorRetrieveVariableValuePairs ];
		sorted: [:assoc1 :assoc2 | assoc1 key < assoc2 key];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
"		icon: [ :each |
			each value class theNonMetaClass browserIcon
				ifNotNil: [ OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ] ];"
		send: #value;
		morphicSelectionAct: [:each | each value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse'! !

GLMBrowserTemplate subclass: #GTSimpleMethodsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 5/20/2012 00:53'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Methods'.
	browser
		row: #methods;
		row: #source.
	browser transmit
		to: #methods;
		andShow: [ :a | self methodsIn: a ].
	browser transmit
		from: #methods;
		fromOutsidePort: #entity;
		to: #source;
		andShow: [ :a | self sourceIn: a ].
	browser transmit
		toOutsidePort: #selection;
		from: #methods port: #evaluatedObject.
	browser transmit
		toOutsidePort: #selection;
		from: #source port: #evaluatedObject.
	^ browser! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 8/27/2011 23:30'!
evaluationAction
	^ GLMGenericAction new
		action: [ :listPresentation :obj | 
					| result |
					result := obj perform: listPresentation selection selector.
					(listPresentation pane port: #evaluatedObject) value: result ];
		shortcut: $o;
		title: 'Do it and open';
		yourself! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 8/19/2011 23:44'!
methodActionsFor: list
	^ list selection selector isUnary
		ifTrue: [ Array with: self evaluationAction ]
		ifFalse: [ #() ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 4/14/2012 22:38'!
methodsIn: a
	^ a list
		display: [ :object | object class methods ];
		sorted: [ :method1 :method2 | method1 selector < method2 selector ];
		format: [ :method | method selector ];
		morphicSelectionAct: [ :list :object | Smalltalk tools browser fullOnClass: object class selector: list selection selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse';
		dynamicActionsOnSelection: [ :list | self methodActionsFor: list ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 10/3/2011 07:37'!
sourceIn: a
	^ a smalltalkCode
		display: [ :method | method getSource ];
		smalltalkClass: [ :method | method methodClass ];
		doItReceiver: [ :method :entity | entity ];
		selectionPopulate: #evaluatedObject
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :method :entity | Compiler evaluate: text selectedText for: entity logged: false ]! !

GLMBrowserTemplate subclass: #GTSimpleParseTreeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTSimpleParseTreeBrowser commentStamp: 'TudorGirba 8/23/2011 01:10' prior: 0!
This is a simple browser that displays the rb tree and previews each node on the source code.

Example:
self openOn: (self>>#buildBrowser) parseTree!

!GTSimpleParseTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 5/20/2012 00:53'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Tree'.
	browser
		row: #tree;
		row: #source.
	browser transmit
		to: #tree;
		andShow: [ :a | self treeIn: a ].
	browser transmit
		to: #source;
		andShow: [ :a | self sourceIn: a ].
	browser transmit
		from: #tree;
		to: #source port: #selectionInterval;
		transformed: [ :rbNode | rbNode sourceInterval ].
	browser transmit
		toOutsidePort: #selection;
		from: #tree port: #selectedNode.
	^ browser! !

!GTSimpleParseTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 8/23/2011 01:16'!
sourceIn: a
	^ a text display: [ :each | each source ]! !

!GTSimpleParseTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 8/23/2011 01:17'!
treeIn: a
	^ a tree
		rootsExpanded;
		display: [ :anObject | {anObject} ];
		children: [ :each | each children ];
		selectionPopulate: #selectedNode
			on: $o
			entitled: 'Open'
			with: [ :tree | tree selection ];
		format: [ :each | 
					String
						streamContents: [ :stream | 
							stream
								nextPutAll: each class name;
								nextPut: $(;
								nextPutAll: ((each formattedCode truncateTo: 50) copyReplaceAll: String cr with: String space);
								nextPut: $) ] ]! !
